unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SQLParserComp, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    QueryParser: TQueryParserComp;
    Panel1: TPanel;
    panButtons: TPanel;
    btnNextToken: TButton;
    edFirstToken: TButton;
    panEdits: TPanel;
    edToken: TEdit;
    lblToken: TLabel;
    lblTokenType: TLabel;
    edTokenType: TEdit;
    lblStringDelimiter: TLabel;
    edStringDelimiter: TEdit;
    lblWordsCount: TLabel;
    edWordsCount: TEdit;
    memTextToParse: TMemo;
    btnSetText: TButton;
    btnAll: TButton;
    procedure btnNextTokenClick(Sender: TObject);
    procedure edFirstTokenClick(Sender: TObject);
    procedure btnSetTextClick(Sender: TObject);
    procedure btnAllClick(Sender: TObject);
    procedure QueryParserStatementDelimiter(Sender: TObject;
      SQLStatement: String);
  private
    { Private declarations }
    procedure SetValues;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.btnNextTokenClick(Sender: TObject);
begin
  QueryParser.NextToken;
  SetValues;
end;

procedure TMainForm.SetValues;
begin
  edToken.Text := QueryParser.Token;
  edWordsCount.Text := IntToStr(QueryParser.SymbolsCount);
  edStringDelimiter.Text := QueryParser.CurrentStringDelimiter;
  case QueryParser.TokenType of
    ttSymbol: edTokenType.Text := 'Symbol';
    ttString: edTokenType.Text := 'String';
    ttDelimiter: edTokenType.Text := 'Delimiter';
    ttComment: edTokenType.Text := 'Comment';
    ttCommentedSymbol: edTokenType.Text := 'Commented Symbol';
    ttSpecialChar: edTokenType.Text := 'Special Character';
    ttStatementDelimiter: edTokenType.Text := 'Statement Delimiter';
    ttCommentDelimiter: edTokenType.Text := 'Comment Delimiter';
  end;
end;

procedure TMainForm.edFirstTokenClick(Sender: TObject);
begin
  QueryParser.FirstToken;
  SetValues;
end;

procedure TMainForm.btnSetTextClick(Sender: TObject);
begin
  QueryParser.TextToParse := memTextToParse.Text;
end;

procedure TMainForm.btnAllClick(Sender: TObject);
begin
  QueryParser.FirstToken;
  while not QueryParser.EOF do
    QueryParser.NextToken;
end;

procedure TMainForm.QueryParserStatementDelimiter(Sender: TObject;
  SQLStatement: String);
begin
  ShowMessage(SQLStatement);
end;

end.
